#!/usr/bin/python3.4
# -*-coding:Utf-8 -*
from tkinter import *
from tkinter.messagebox import *


class CurseurEditable(LabelFrame):
    """fenêtre principale"""

    def __init__(self, fenetre, valeur, titre='', nom='V', min=0.0, max=100.0, resol=1.0, unit='V', couleur='black',
                 **kwargs):
        Frame.__init__(self, fenetre, width=1024, height=768, borderwidth=2, relief=GROOVE, **kwargs)
        self.pack(side=LEFT, padx=10, pady=10)

        self.tit = titre
        self.text = nom
        self.mini = min
        self.maxi = max
        self.res = resol
        self.unite = unit
        self.coul = couleur

        self.curseur = True

        self.reglages = LabelFrame(self, text=titre, padx=0, pady=15)  # cadre

        self.label_V = Label(self.reglages, text=nom, font='Arial, 14', fg=couleur)
        self.label_V.grid(row=1, column=1)

        self.val_V = DoubleVar()  # variable associée à l'ensemble
        self.val_V = valeur

        self.val_cur = DoubleVar()  # variable associée au curseur
        self.curseur_V = Scale(self.reglages, showvalue=0, from_=min, to=max, resolution=resol, orient=HORIZONTAL,
                               command=self.Vchange, length=300, variable=self.val_cur, fg=couleur)
        #  self.curseur_V.bind("<B1-Motion>",self.Vchange)#si cliqué-glissé, exécuter Vchange mais c'est mieux avec command
        self.curseur_V.grid(row=1, column=2)

        self.string_V = StringVar()  # variable de la zone d'entrée de V
        self.Entry_val_V = Entry(self.reglages, textvariable=self.string_V, width=5, font='Arial, 14', fg=couleur)
        self.Entry_val_V.bind("<KeyPress>", self.eValide)
        self.Entry_val_V.grid(row=1, column=3)

        self.label_U = Label(self.reglages, text=unit, font='Arial, 14', fg=couleur)
        self.label_U.grid(row=1, column=4)

        self.reglages.pack()

    def Vchange(self, value):
        """le curseur V a été cliqué on change la valeur"""
        if self.curseur:
            self.string_V.set(value)  # on peut utiliser aussi curseur_V.get() ou "%g" %self.val_V.get()
            self.val_V.set(value)
        self.curseur = True

    def eValide(self, event):
        """on a tapé entrée dans Entry_V"""
        self.curseur = False
        if event.keysym == "Return" or event.keysym == "KP_Enter":
            # self.curseur_V.set(float(self.Entry_val_V.get() ))
            self.val_V.set(self.string_V.get())
            self.val_cur.set(self.string_V.get())  #  on rafraichit le curseur

    def get(self):
        return float(self.string_V.get())

    def set(self, valeur):
        self.string_V.set("%g" % valeur)
        self.val_V.set(valeur)
        self.val_cur.set(valeur)

    def disable(self):
        self.curseur_V.configure(state=DISABLED, fg='gray')
        self.Entry_val_V.configure(state=DISABLED, fg='gray')

    def enable(self):
        self.curseur_V.configure(state=NORMAL, fg=self.coul)
        self.Entry_val_V.configure(state=NORMAL, fg=self.coul)

    def configure(self, titre='$', nom='$', min=9.2, max=9.2, resol=9.2, unit='$',
                  couleur='$'):  # valeurs par défaut farfelues pour savoir si on a affecté la variable
        if titre != '$': self.reglages.configure(text=titre)
        if nom != '$': self.label_V.configure(text=nom)
        if couleur != '$':
            self.label_V.configure(fg=couleur)
            self.curseur_V.configure(fg=couleur)
            self.Entry_val_V.configure(fg=couleur)
            self.label_U.configure(fg=couleur)
        if min != 9.2:
            self.curseur_V['from'] = min  # bug dans .configure : on ne peut pas y fixer 'from' ! (->invalid syntax)
            self.curseur_V.configure(to=max, resolution=resol)  # si on a ffecté min, alors max et résol aussi
        if unit != '$': self.label_U.configure(text=unit)


def main():
    fen = Tk()
    fen['bg'] = 'white'
    fen.title('titre!')
    fen['width'] = 1800  # ignoré
    fen['height'] = 600
    MonInter = CurseurEditable(fen, titre='tension aux bornes', max=230.0, nom='V')

    MonInter.mainloop()


if __name__ == '__main__':  # if we're running file directly and not importing it
    main()  # run the main function
