#!/usr/bin/python3
# -*-coding:Utf-8 -*
from  tkinter import *
from tkinter.messagebox import *
from CurEdit import *#importe la classe du fichier local CurEdit.py
from math import *
import os


class Interface(LabelFrame):
	"""fenêtre principale"""
	
	def __init__(self, fenetre, **kwargs):
		LabelFrame.__init__(self, fenetre,text="Diagramme de la machine synchrone", borderwidth=2, relief=GROOVE, **kwargs)
		self.pack(side=LEFT, padx=10, pady=10)

		#  taille de l'écran
		self.h = int(self.winfo_screenheight() * 0.7)
		self.w = int(self.h*4/3)
		# Création de nos widgets
		self.message = Label(self, text="Clic gauche : zoom avant       Clic droit : zoom arrière")
		
		#  initialisations
		self.OrigineX = int(self.w/10)
		self.OrigineY = int(self.h/2)
		self.echelle = 1.0
		self.signe = 1
		
		#  dessin
		self.dessin = Canvas(self, width=self.w, height=self.h, background='white')
		self.axeP = self.dessin.create_line(240, self.h, 240, 0, arrow='last', arrowshape = '15 20 5', fill='black',width=1)
		self.axeQ = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY, arrow='last', arrowshape = '15 20 5', fill='black',width=1)
		self.horiz = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY, dash=(4,4), fill='black',width=1)
		self.vertic = self.dessin.create_line(0, self.OrigineY, self.w, self.OrigineY,  dash=(4,4), fill='black',width=1)
		
		self.ligneV = self.dessin.create_line(self.OrigineX, self.OrigineY, 240, self.OrigineY, arrow='last', arrowshape = '20 30 8', fill='blue',width=3)
		self.ligneE = self.dessin.create_line(self.OrigineX, self.OrigineY, 300, 60, arrow='last', arrowshape = '20 30 8', fill='green',width=2)
		self.ligneXI = self.dessin.create_line(240, self.OrigineY, 300, 60, arrow='last', arrowshape = '20 30 8', fill='red', width=2)
		self.ligneI = self.dessin.create_line(240, self.OrigineY, 300, 60, arrow='last', arrowshape = '15 20 5', dash=(4,4), fill='red', width=2)

		self.txtV = self.dessin.create_text(75, 60, text="V", font="Arial 16 underline", fill="blue")
		self.txtE = self.dessin.create_text(75, 60, text="E", font="Arial 16 underline", fill="green")
		self.txtXI = self.dessin.create_text(75, 60, text="XI", font="Arial 16 underline", fill="red")
		self.txtI = self.dessin.create_text(75, 60, text="I", font="Arial 14 underline", fill="red")
		self.txtO = self.dessin.create_text(75, 60, text="O", font="Arial 14", fill="black")
		self.txtA = self.dessin.create_text(75, 60, text="A", font="Arial 14", fill="black")
		self.txtB = self.dessin.create_text(75, 60, text="B", font="Arial 14", fill="black")
		self.txtDecrochage = self.dessin.create_text(400, 60, text="", font="Arial 18", fill="red")

		self.dessin.bind('<Button-1>', self.zoom)
		self.dessin.bind('<Button-3>', self.zoom)

		#  zone de réglages et de mesures
		self.reglages = PanedWindow(self, orient=VERTICAL)

		self.gene = IntVar()
		CB_G = Checkbutton(self.reglages,text='génératrice',variable=self.gene, font='Arial, 10')
		self.gene.trace('w',self.M_G)
		
		self.reseau = IntVar()
		CB_R = Checkbutton(self.reglages,text='couplage au réseau',variable=self.reseau, font='Arial, 10')
		self.reseau.trace('w',self.R_A)
		
		frame_L = Frame(self.reglages, pady = 10)
		self.string_L = StringVar()
		self.string_L.set('0.1')
		Label_L = Label(frame_L, text = 'Inductance synchrone : ', font = 'Arial, 10')
		Entry_L = Entry(frame_L, textvariable = self.string_L, width=8, font = 'Arial, 10')
		Entry_L.bind("<KeyPress>",self.eValide)
		Label_H = Label(frame_L, text = 'H', font = 'Arial, 10')
		
		self.string_f = StringVar()
		self.string_f.set('50')
		Label_f = Label(frame_L, text = 'fréquence : ', font = 'Arial, 10')
		Entry_f = Entry(frame_L, textvariable = self.string_f, width=8, font = 'Arial, 10')
		Entry_f.bind("<KeyPress>",self.eValide)
		Label_Hz = Label(frame_L, text = 'Hz', font = 'Arial, 10')
		
		Label_L.grid(row=1, column=1)
		Entry_L.grid(row=1, column=2)
		Label_H.grid(row=1, column=3)
		Label_f.grid(row=2, column=1)
		Entry_f.grid(row=2, column=2)
		Label_Hz.grid(row=2, column=3)

		self.val_V = DoubleVar()
		self.C_V=CurseurEditable(self.reglages, valeur=self.val_V, titre="Tension aux bornes de l'induit de la machine",nom=' V ', min=0.0, max=300.0, resol=1,couleur='blue', unit='V')
		self.val_V.trace("w",self.tracer)#si V est changé ça déclenche le tracé
		self.val_I_P = DoubleVar()
		self.C_I_P=CurseurEditable(self.reglages, valeur=self.val_I_P, titre="Courant d'induit",nom=' I ', min=0.0, max=15.0, resol=0.1, unit='A',couleur = 'red')
		self.val_I_P.trace("w",self.tracer)
		
		self.val_phi_E = DoubleVar()
		self.C_phi_E=CurseurEditable(self.reglages, valeur = self.val_phi_E, titre="Déphasage",nom=' φ ', min=-180, max=180, resol=1,  unit='°')
		self.val_phi_E.trace("w",self.tracer)
		
		self.aff1 = Label(self, text = 'E = 0V', fg='green', font='Arial, 12', bg='#eeeeee', pady=5)#ancienne c6b6dd
		self.aff2 = Label(self, text = 'P = 0W', fg='black', font='Arial, 12', bg='#eeeeee', pady=5)
		self.aff3 = Label(self, text = 'Q = 0VAR', fg='black', font='Arial, 12', bg='#eeeeee', pady=5)
		self.aff4 = Label(self, text = 'S = 0VA', fg='black', font='Arial, 12', bg='#eeeeee', pady=5)
		
		self.reglages.add(CB_R)
		self.reglages.add(CB_G)
		self.reglages.add(frame_L)
		self.reglages.add(self.C_V)
		self.reglages.add(self.C_I_P)
		self.reglages.add(self.C_phi_E)
		self.reglages.add(self.aff1, pady=10)
		self.reglages.add(self.aff2, pady=10)
		self.reglages.add(self.aff3, pady=10)
		self.reglages.add(self.aff4, pady=10)

		#  pack!
		self.reglages.pack(side="left")
		self.message.pack()
		self.dessin.pack()

		#  initialisation des variables
		self.init = True  #  permet de ne pas tracer tant que tout n'est pas ficé
		self.reseau.set(False)
		self.C_V.set(230)
		self.C_I_P.set(2)
		self.C_phi_E.set(30)
		self.P = 0.0
		self.phi = 30.0
		self.I = 2.0
		self.E = 0.0
		self.gene.set(True)
		self.init = False
		self.tracer()

	def zoom(self, event):
		if event.num == 1: self.echelle = self.echelle + 0.2  #  bouton gauche zoome
		if event.num == 3: self.echelle = self.echelle - 0.2  #  bouton droit dézoome
		self.tracer()
		
	def eValide(self, event):
		"""on a tapé entrée dans Entry_L ou f"""
		if event.keysym == "Return": self.tracer()
	
	def R_A(self, *args):
		"""couplée au réseau ou pas"""
		if not self.init:
			
			if self.reseau.get():
				self.C_V.disable() #  V reste constante à la valeur au moment où l'on a cliqué sur la case
				self.C_I_P.configure(titre='Puissance active échangée avec le réseau', nom='P', couleur='black', min = -10, max = 10, resol = 0.1, unit = 'kW')
				self.C_phi_E.configure(titre='fém de la machine', nom='E', couleur='green',min = 0, max = 500, resol = 1, unit = 'V')
			
				self.C_I_P.set(float('{:2.2f}'.format(self.P)))  #  self.P et self.E ne sont calculés que si on n'est pas couplé au réseau. Astuce pour arrondir par{4.0f}...
				self.C_phi_E.set(float('{:4.0f}'.format(self.E)))
			
			else:
				self.init=True  #  permet de ne pas tracer tant que tout n'est pas prêt
				self.C_V.enable()
				self.C_I_P.configure(titre="Courant d'induit", nom = 'I', couleur='red', min=0.0, max=15.0, resol = 0.1, unit = 'A')
				self.C_phi_E.configure(titre='déphasage', nom = 'φ', couleur='black', min=-180, max=180, resol = 1, unit = '°')
				
				self.C_I_P.set(float('{:2.2f}'.format(self.I)))  #  self.P et self.E ne sont calculés que si on n'est pas couplé au réseau. Astuce pour arrondir par{4.0f}...
				self.C_phi_E.set(float('{:4.0f}'.format(self.phi*180/pi)))
				self.init=False
				self.tracer()
			
	def M_G(self, *args):
		"""passe de géné à moteur et vice versa"""
		if self.gene.get():
			self.signe=1
			self.dessin.itemconfig(self.txtXI, text='XI')
			self.dessin.itemconfig(self.axeP,arrow='last')
			self.dessin.itemconfig(self.axeQ,arrow='last')
		else:
			self.signe=-1
			self.dessin.itemconfig(self.txtXI, text='-XI')
			self.dessin.itemconfig(self.axeP,arrow='first')
			self.dessin.itemconfig(self.axeQ,arrow='first')
			
		self.tracer()

	def tracer(self, *args): #  la mention *args permet d'accepter tous les arguments de l'évennement traité
		"""Tracé du diagramme."""
		
		if not self.init:
			V = float(self.val_V.get())
			
			if self.reseau.get():
				self.P = float(self.val_I_P.get())
				E = float(self.val_phi_E.get())
				OA = self.P * 1000.0 * float( self.string_L.get() ) * float( self.string_f.get() ) * 2 * pi / 3.0 / V #abs(OA)
			
				if E < OA:
					self.dessin.itemconfig(self.txtDecrochage, text='Décrochage !')
				
				else:
					self.dessin.itemconfig(self.txtDecrochage, text='')
					Lomega = float( self.string_L.get() ) * float( self.string_f.get() ) * 2 * pi
					OB = sqrt(E * E - OA * OA) - V
					self.I = 1.0 / Lomega * sqrt(OA * OA + OB * OB)
					S = 3.0 * V * self.I / 1000
				
					if OB >= 0:
						self.phi = self.signe * acos(self.P / S)
					else:
						self.phi = - self.signe * acos(self.P / S)
				
					self.aff1.configure(text = "I = {:2.2f} A".format(self.I), fg = 'red')
					self.aff2['text'] = "φ = {:3.0f} °".format(self.phi * 180.0 / pi)
					self.aff3['text'] = "Q = {:2.2f} kVAR".format(S * sin(self.phi))
					self.aff4['text'] = "S = {:2.2f} kVA".format(S)
				
					LomegaI = Lomega * self.I * self.signe
					yV = self.OrigineY
					xV = self.OrigineX + V*self.echelle
					yI = self.OrigineY + self.I * sin(self.phi) * 15 * self.echelle
					xI = self.OrigineX + self.I * cos(self.phi) * 15 * self.echelle
					xL = xV + LomegaI * sin(self.phi) * self.echelle 
					yL = self.OrigineY - LomegaI * cos(self.phi) * self.echelle
			
					#  tracé
					self.dessin.coords(self.ligneV, self.OrigineX, self.OrigineY, xV, yV)
					self.dessin.coords(self.ligneE, self.OrigineX, self.OrigineY, xL, yL)
					self.dessin.coords(self.ligneXI, xV, yV, xL, yL)
					self.dessin.coords(self.ligneI, self.OrigineX, self.OrigineY, xI, yI)
	
					self.dessin.coords(self.axeP, xV, self.h, xV, 0)
					self.dessin.coords(self.horiz, 0, yL, self.w, yL)
					self.dessin.coords(self.vertic, xL, self.h, xL, 0)

					self.dessin.coords(self.txtV, xV/2, yV+20)
					self.dessin.coords(self.txtE, xL/2 - 20, self.OrigineY + (yL - self.OrigineY)/2 - 20)
					self.dessin.coords(self.txtXI, xV + (xL-xV)/2 + 20, self.OrigineY + (yL - self.OrigineY)/2 + 20)
					self.dessin.coords(self.txtI, xI + 10, yI + 10)
					self.dessin.coords(self.txtO, xV + 10, yV - 10)
					self.dessin.coords(self.txtA, xV-10, yL)
					self.dessin.coords(self.txtB, xL, yV+20)

			else:
				#  coordonnées
				self.phi = float(self.val_phi_E.get()) * pi /180  #phi en rad
				self.I = float(self.val_I_P.get())
				LomegaI = float( self.string_L.get() ) * float( self.string_f.get() )* 2 * pi * self.I * self.signe
				yV = self.OrigineY
				xV = self.OrigineX + V*self.echelle
				yI = self.OrigineY + self.I * sin(self.phi) * 15 * self.echelle
				xI = self.OrigineX + self.I * cos(self.phi) * 15 * self.echelle
				xL = xV + LomegaI * sin(self.phi) * self.echelle 
				yL = self.OrigineY - LomegaI * cos(self.phi) * self.echelle
			
				#  tracé
				self.dessin.coords(self.ligneV, self.OrigineX, self.OrigineY, xV, yV)
				self.dessin.coords(self.ligneE, self.OrigineX, self.OrigineY, xL, yL)
				self.dessin.coords(self.ligneXI, xV, yV, xL, yL)
				self.dessin.coords(self.ligneI, self.OrigineX, self.OrigineY, xI, yI)
	
				self.dessin.coords(self.axeP, xV, self.h, xV, 0)
				self.dessin.coords(self.horiz, 0, yL, self.w, yL)
				self.dessin.coords(self.vertic, xL, self.h, xL, 0)

				self.dessin.coords(self.txtV, xV/2, yV+20)
				self.dessin.coords(self.txtE, xL/2 - 20, self.OrigineY + (yL - self.OrigineY)/2 - 20)
				self.dessin.coords(self.txtXI, xV + (xL-xV)/2 + 20, self.OrigineY + (yL - self.OrigineY)/2 + 20)
				self.dessin.coords(self.txtI, xI + 10, yI + 10)
				self.dessin.coords(self.txtO, xV + 10, yV - 10)
				self.dessin.coords(self.txtA, xV-10, yL)
				self.dessin.coords(self.txtB, xL, yV+20)

				#  mesures
				self.E = sqrt( pow( V+LomegaI*sin(self.phi) ,2.0) + pow( LomegaI*cos(self.phi) ,2.0) )
				S = 3.0*V*self.val_I_P.get()/1000.0
				self.P = S*cos(self.phi)
				Q = S*sin(self.phi)
				self.aff1['text'] = "E = {:4.0f} V".format(self.E)
				self.aff2['text'] = "P = {:2.2f} kW".format(self.P)
				self.aff3['text'] = "Q = {:2.2f} kVAR".format(Q)
				self.aff4['text'] = "S = {:2.2f} kVA".format(S)
	

fen=Tk()
fen['bg'] = 'white'
fen.title('Diagramme de la machine synchrone P. Philip 2018')
MonInter = Interface(fen)

MonInter.mainloop()

